## nng 1.7.3

=== CMakeLists.txt ===
#
#   Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
#   Copyright (c) 2012 Martin Sustrik  All rights reserved.
#   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
#   Copyright (c) 2015-2016 Jack R. Dunaway. All rights reserved.
#   Copyright 2016 Franklin "Snaipe" Mathieu <franklinmathieu@gmail.com>
#   Copyright 2018 Capitar IT Group BV <info@capitar.com>
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom
#   the Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
#   IN THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.13)

project(nng C)
include(CheckCCompilerFlag)
include(GNUInstallDirs)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(NNGHelpers)
include(NNGOptions)

set(CMAKE_C_STANDARD 99)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
if ("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif ("${isSystemDir}" STREQUAL "-1")

set(NNG_DESCRIPTION "High-Performance Scalability Protocols NextGen")
set(ISSUE_REPORT_MSG "Please consider opening an issue at https://github.com/nanomsg/nng")

# Determine library versions.
file(READ "include/nng/nng.h" nng_ver_h)
string(REGEX MATCH "NNG_MAJOR_VERSION ([0-9]*)" _ ${nng_ver_h})
set(NNG_MAJOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "NNG_MINOR_VERSION ([0-9]*)" _ ${nng_ver_h})
set(NNG_MINOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "NNG_PATCH_VERSION ([0-9]*)" _ ${nng_ver_h})
set(NNG_PATCH_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "NNG_RELEASE_SUFFIX \"([a-z0-9]*)\"" _ ${nng_ver_h})
if (NOT ("${CMAKE_MATCH_1}" STREQUAL ""))
    set(NNG_PRERELEASE "-${CMAKE_MATCH_1}")
endif ()

set(NNG_ABI_SOVERSION 1)
set(NNG_ABI_VERSION "${NNG_MAJOR_VERSION}.${NNG_MINOR_VERSION}.${NNG_PATCH_VERSION}${NNG_PRERELEASE}")
set(NNG_PACKAGE_VERSION "${NNG_ABI_VERSION}")
message(STATUS "Configuring for NNG version ${NNG_ABI_VERSION}")

# User-defined options.

# This prefix is appended to by subdirectories, so that each test
# gets named based on where it is in the tree.
set(NNG_TEST_PREFIX nng)

# Enable access to private APIs for our own use.
add_definitions(-DNNG_PRIVATE)

if (NOT (BUILD_SHARED_LIBS))
    set(NNG_STATIC_LIB ON)
    message(STATUS "Building static libs.")
endif ()

# These are library targets.  The "nng" library is the main public library.
# The "nng_testing" is a full build of the library for test cases
# only, which is done statically and includes even portions of the code
# that are not part of the public library (things that may have been elided.)
# The "nng_private" library is an interface that allows some internal tools
# to obtain details about how the public library was built, so that we can
# include or not include code based on what's actually present.
add_library(nng)

add_library(nng_testing STATIC EXCLUDE_FROM_ALL)
target_compile_definitions(nng_testing PUBLIC NNG_STATIC_LIB NNG_TEST_LIB NNG_PRIVATE)

add_library(nng_private INTERFACE)
target_compile_definitions(nng_private INTERFACE NNG_PRIVATE)

if (NNG_ELIDE_DEPRECATED)
    target_compile_definitions(nng PRIVATE NNG_ELIDE_DEPRECATED)
endif()
if (NNG_ENABLE_COMPAT)
    target_compile_definitions(nng PRIVATE NNG_ENABLE_COMPAT)
endif()


# We can use rlimit to configure the stack size for systems
# that have too small defaults.  This is not used for Windows,
# which can grow thread stacks sensibly.  (Note that NNG can get
# by with a smallish stack, but application callbacks might require
# larger values if using aio completion callbacks.  TLS libraries may
# require larger stacks however.)
if (NOT WIN32)
    option(NNG_SETSTACKSIZE "Use rlimit for thread stack size" OFF)
    if (NNG_SETSTACKSIZE)
        add_definitions(-DNNG_SETSTACKSIZE)
    endif ()
    mark_as_advanced(NNG_SETSTACKSIZE)
endif ()

nng_defines_if(NNG_ENABLE_STATS NNG_ENABLE_STATS)

# IPv6 enable
nng_defines_if(NNG_ENABLE_IPV6 NNG_ENABLE_IPV6)

set(NNG_RESOLV_CONCURRENCY 4 CACHE STRING "Resolver (DNS) concurrency.")
mark_as_advanced(NNG_RESOLV_CONCURRENCY)
if (NNG_RESOLV_CONCURRENCY)
    add_definitions(-DNNG_RESOLV_CONCURRENCY=${NNG_RESOLV_CONCURRENCY})
endif ()

set(NNG_NUM_TASKQ_THREADS 0 CACHE STRING "Fixed number of task threads, 0 for automatic")
mark_as_advanced(NNG_NUM_TASKQ_THREADS)
if (NNG_NUM_TASKQ_THREADS)
    add_definitions(-DNNG_NUM_TASKQ_THREADS=${NNG_NUM_TASKQ_THREADS})
endif ()

set(NNG_MAX_TASKQ_THREADS 16 CACHE STRING "Upper bound on task threads, 0 for no limit")
mark_as_advanced(NNG_MAX_TASKQ_THREADS)
if (NNG_MAX_TASKQ_THREADS)
    add_definitions(-DNNG_MAX_TASKQ_THREADS=${NNG_MAX_TASKQ_THREADS})
endif ()

# Expire threads. This runs the timeout handling, and having more of them
# reduces contention on the common locks used for aio expiration.
set(NNG_NUM_EXPIRE_THREADS 0 CACHE STRING "Fixed number of expire threads, 0 for automatic")
mark_as_advanced(NNG_NUM_EXPIRE_THREADS)
if (NNG_NUM_EXPIRE_THREADS)
    add_definitions(-DNNG_NUM_EXPIRE_THREADS=${NNG_NUM_EXPIRE_THREADS})
endif ()

set(NNG_MAX_EXPIRE_THREADS 8 CACHE STRING "Upper bound on expire threads, 0 for no limit")
mark_as_advanced(NNG_MAX_EXPIRE_THREADS)
if (NNG_MAX_EXPIRE_THREADS)
    add_definitions(-DNNG_MAX_EXPIRE_THREADS=${NNG_MAX_EXPIRE_THREADS})
endif()

# Poller threads.  These threads run the pollers.  This is mostly used
# on Windows right now, as the POSIX platforms use a single threaded poller.
set(NNG_NUM_POLLER_THREADS 0 CACHE STRING "Fixed number of I/O poller threads, 0 for automatic")
if (NNG_NUM_POLLER_THREADS)
    add_definitions(-DNNG_NUM_POLLER_THREADS=${NNG_NUM_POLLER_THREADS})
endif ()
mark_as_advanced(NNG_NUM_POLLER_THREADS)

set(NNG_MAX_POLLER_THREADS 8 CACHE STRING "Upper bound on I/O poller threads, 0 for no limit")
mark_as_advanced(NNG_MAX_POLLER_THREADS)
if (NNG_MAX_POLLER_THREADS)
    add_definitions(-DNNG_MAX_POLLER_THREADS=${NNG_MAX_POLLER_THREADS})
endif()

#  Platform checks.

if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    set(NNG_WARN_FLAGS "-Wall -Wextra -fno-omit-frame-pointer")
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
    set(NNG_WARN_FLAGS "-Wall -Wextra -fno-omit-frame-pointer")
endif ()

include(CheckSanitizer)
CheckSanitizer()
if (NOT NNG_SANITIZER STREQUAL "none")
    set(NNG_SANITIZER_FLAGS "-fsanitize=${NNG_SANITIZER}")
endif ()

if (NNG_ENABLE_COVERAGE)
    # NB: This only works for GCC and Clang 3.0 and newer.  If your stuff
    # is older than that, you will need to find something newer.  For
    # correct reporting, we always turn off all optimizations.
    if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
        set(NNG_COVERAGE_C_FLAGS "-g -O0 --coverage")
        set(CMAKE_SHARED_LINKER_FLAGS --coverage)
    elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
        set(NNG_COVERAGE_C_FLAGS "-g -O0 --coverage")
        set(CMAKE_SHARED_LINKER_FLAGS --coverage)
    else ()
        message(FATAL_ERROR "Unable to enable coverage for your compiler.")
    endif ()
endif ()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${NNG_WARN_FLAGS} ${NNG_COVERAGE_C_FLAGS} ${NNG_SANITIZER_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${NNG_WARN_FLAGS} ${NNG_COVERAGE_C_FLAGS} ${NNG_SANITIZER_FLAGS}")

# If the compiler is not on Windows, does it support hiding the
# symbols by default?  For shared libraries we would like to do this.
if (NOT WIN32 AND NOT CYGWIN)
    check_c_compiler_flag(-fvisibility=hidden NNG_HIDDEN_VISIBILITY)
    if (NNG_HIDDEN_VISIBILITY)
        add_definitions(-DNNG_HIDDEN_VISIBILITY)
    endif ()
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_LINUX)
    add_definitions(-DNNG_USE_EVENTFD)
    add_definitions(-DNNG_HAVE_ABSTRACT_SOCKETS)
    # Windows subsystem for Linux -- smells like Linux, but it has
    # some differences (SO_REUSEADDR for one).
    if (CMAKE_SYSTEM_VERSION MATCHES "Microsoft")
        add_definitions(-DNNG_PLATFORM_WSL)
    endif ()
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "Android")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_LINUX)
    add_definitions(-DNNG_PLATFORM_ANDROID)
    add_definitions(-DNNG_USE_EVENTFD)
    set(NNG_PLATFORM_POSIX ON)

elseif (APPLE)
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_DARWIN)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_FREEBSD)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "NetBSD")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_NETBSD)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_OPENBSD)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "SunOS")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_SUNOS)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "Windows")
    add_definitions(-DNNG_PLATFORM_WINDOWS)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-D_CRT_RAND_S)
    set(NNG_PLATFORM_WINDOWS ON)

    # Target Windows Vista and later
    add_definitions(-D_WIN32_WINNT=0x0600)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_WIN32_WINNT=0x0600)

elseif (CMAKE_SYSTEM_NAME MATCHES "QNX")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-D__EXT_BSD)
    add_definitions(-D_QNX_SOURCE)
    add_definitions(-DNNG_PLATFORM_QNX)
    set(NNG_PLATFORM_POSIX ON)

else ()
    message(AUTHOR_WARNING "WARNING: This platform may not be supported: ${CMAKE_SYSTEM_NAME}")
    message(AUTHOR_WARNING "${ISSUE_REPORT_MSG}")
    # blithely hope for POSIX to work
    add_definitions(-DNNG_PLATFORM_POSIX)
    set(NNG_PLATFORM_POSIX ON)
endif ()

if (NNG_ENABLE_TLS)
    add_definitions(-DNNG_SUPP_TLS)
endif ()

if (NNG_TESTS)
    enable_testing()
    set(all_tests, "")
endif ()

add_subdirectory(src)

if (NNG_TESTS)
    add_subdirectory(tests)
endif ()

#  Build the tools

add_subdirectory(docs/man)

set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
set(CPACK_PACKAGE_VERSION ${NNG_PACKAGE_VERSION})
set(CPACK_PACKAGE_CONTACT "nanomsg@freelists.org")
set(CPACK_PACKAGE_VENDOR "nanomsg.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "nanomsg next generation library")
set(CPACK_SOURCE_GENERATOR "TBZ2;TGZ;ZIP")
set(CPACK_SOURCE_IGNORE_FILES "/build/;/.git/;~$;${CPACK_SOURCE_IGNORE_FILES}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
        "${PROJECT_NAME}-v${NNG_PACKAGE_VERSION}-src")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt)
set(CPACK_PACKAGE_INSTALL_DIRECTORY "nng")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-v${NNG_PACKAGE_VERSION}")

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
include(CPack)

=== src/platform/posix/CMakeLists.txt ===
#
# Copyright 2023 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  POSIX.

# We cannot use nng_sources_if because these tests don't go into
# the static library unless they also go into the dynamic.
if (NNG_PLATFORM_POSIX)

    nng_find_package(Threads)
    nng_link_libraries(Threads::Threads)

    # Unconditionally declare the following feature test macros.  These are
    # needed for some platforms (glibc and SunOS/illumos) and are harmless
    # on the others.
    nng_defines(_GNU_SOURCE)
    nng_defines(_REENTRANT)
    nng_defines(_THREAD_SAFE)
    nng_defines(_POSIX_PTHREAD_SEMANTICS)

    nng_check_func(lockf NNG_HAVE_LOCKF)
    nng_check_func(flock NNG_HAVE_FLOCK)
    nng_check_func(getrandom NNG_HAVE_GETRANDOM)
    nng_check_func(arc4random_buf NNG_HAVE_ARC4RANDOM)

    nng_check_lib(rt clock_gettime NNG_HAVE_CLOCK_GETTIME)
    nng_check_lib(pthread sem_wait NNG_HAVE_SEMAPHORE_PTHREAD)
    nng_check_lib(pthread pthread_atfork NNG_HAVE_PTHREAD_ATFORK_PTHREAD)
    nng_check_lib(pthread pthread_set_name_np NNG_HAVE_PTHREAD_SET_NAME_NP)
    nng_check_lib(pthread pthread_setname_np NNG_HAVE_PTHREAD_SETNAME_NP)
    nng_check_lib(nsl gethostbyname NNG_HAVE_LIBNSL)
    nng_check_lib(socket socket NNG_HAVE_LIBSOCKET)

    # GCC needs libatomic on some architectures (e.g. ARM) because the
    # underlying architecture may lack the necessary atomic primitives.
    # One hopes that the libatomic implementation is superior to just using
    # a pthread mutex.  The symbol chosen here was identified from GCC's
    # libatomic map file.
    #
    # Arguably when using clang, compiler-rt might be better.
    nng_check_lib(atomic __atomic_load_1 NNG_HAVE_LIBATOMIC)

    nng_check_sym(AF_UNIX sys/socket.h NNG_HAVE_UNIX_SOCKETS)
    nng_check_sym(backtrace_symbols_fd execinfo.h NNG_HAVE_BACKTRACE)
    nng_check_struct_member(msghdr msg_control sys/socket.h NNG_HAVE_MSG_CONTROL)
    nng_check_sym(eventfd sys/eventfd.h NNG_HAVE_EVENTFD)
    nng_check_sym(kqueue sys/event.h NNG_HAVE_KQUEUE)
    nng_check_sym(port_create port.h NNG_HAVE_PORT_CREATE)
    nng_check_sym(epoll_create sys/epoll.h NNG_HAVE_EPOLL)
    nng_check_sym(epoll_create1 sys/epoll.h NNG_HAVE_EPOLL_CREATE1)
    nng_check_sym(getpeereid unistd.h NNG_HAVE_GETPEEREID)
    nng_check_sym(SO_PEERCRED sys/socket.h NNG_HAVE_SOPEERCRED)
    nng_check_struct_member(sockpeercred uid sys/socket.h NNG_HAVE_SOCKPEERCRED)
    nng_check_sym(LOCAL_PEERCRED sys/un.h NNG_HAVE_LOCALPEERCRED)
    nng_check_sym(LOCAL_PEERPID sys/un.h NNG_HAVE_LOCALPEERPID)
    nng_check_sym(getpeerucred ucred.h NNG_HAVE_GETPEERUCRED)
    nng_check_sym(atomic_flag_test_and_set stdatomic.h NNG_HAVE_STDATOMIC)
    nng_check_sym(socketpair sys/socket.h NNG_HAVE_SOCKETPAIR)
    nng_check_sym(AF_INET6 netinet/in.h NNG_HAVE_INET6)

    nng_sources(
            posix_impl.h
            posix_aio.h
            posix_ipc.h
            posix_config.h
            posix_pollq.h
            posix_tcp.h

            posix_alloc.c
            posix_atomic.c
            posix_clock.c
            posix_debug.c
            posix_file.c
            posix_ipcconn.c
            posix_ipcdial.c
            posix_ipclisten.c
            posix_peerid.c
            posix_pipe.c
            posix_resolv_gai.c
            posix_sockaddr.c
            posix_socketpair.c
            posix_sockfd.c
            posix_tcpconn.c
            posix_tcpdial.c
            posix_tcplisten.c
            posix_thread.c
            posix_udp.c
    )

    if (NNG_HAVE_PORT_CREATE)
        nng_sources(posix_pollq_port.c)
    elseif (NNG_HAVE_KQUEUE)
        nng_sources(posix_pollq_kqueue.c)
    elseif (NNG_HAVE_EPOLL AND NNG_HAVE_EVENTFD)
        nng_sources(posix_pollq_epoll.c)
    else ()
        nng_sources(posix_pollq_poll.c)
    endif ()

    if (NNG_HAVE_ARC4RANDOM)
        nng_sources(posix_rand_arc4random.c)
    elseif (NNG_HAVE_GETRANDOM)
        nng_sources(posix_rand_getrandom.c)
    else ()
        nng_sources(posix_rand_urandom.c)
    endif ()

    nng_test(posix_ipcwinsec_test)

endif ()

=== src/supplemental/tls/mbedtls/CMakeLists.txt ===
#
# Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

if (NNG_TLS_ENGINE STREQUAL "mbed")
    message(WARNING "
        ************************************************************
        Linking against Mbed TLS may change license terms.
        Consult a lawyer and the license files for details.
        ************************************************************")
    nng_sources(tls.c)
    nng_defines(NNG_TLS_ENGINE_INIT=nng_tls_engine_init_mbed)
    nng_defines(NNG_TLS_ENGINE_FINI=nng_tls_engine_fini_mbed)
    nng_defines(NNG_SUPP_TLS)

    # If Mbed TLS was added by a consuming project, then we should use that
    # instance of it, instead of configuring our own.
    if (TARGET mbedtls)
        nng_link_libraries(mbedtls)
    else()
        # We want to prefer config mode over our local find package.
        # mbedTLS v3 has a config file, which should work better than
        # what we do here.  We only make this override locally, to
        # avoid confounding any other package consumers, and we honor overrides.
        if (NOT (DEFINED CMAKE_FIND_PACKAGE_PREFER_CONFIG))
            set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)
            find_package(MbedTLS REQUIRED)
            unset(CMAKE_FIND_PACKAGE_PREFER_CONFIG)
        else()
            find_package(MbedTLS REQUIRED)
        endif()
        nng_link_libraries_public(MbedTLS::mbedtls MbedTLS::mbedcrypto MbedTLS::mbedx509)
    endif()
endif()

=== debian/changelog ===
nng (1.7.3-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 06 Mar 2024 17:54:01 +0100

=== debian/control ===
Source: nng
Section: devel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf, libmbedtls-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://nng.nanomsg.org/

Package: nng-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Lightweight Messaging Library - utility
 Lightweight, broker-less library, offering a simple API to solve
 common recurring messaging problems, such as publish/subscribe,
 RPC-style request/reply, or service discovery. The API frees the
 programmer from worrying about details like connection management,
 retries, and other common considerations, so that they can focus on
 the application instead of the plumbing.
 .
 This package contains the nngcat utility.

Package: libnng1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Messaging Library - shared library
 Lightweight, broker-less library, offering a simple API to solve
 common recurring messaging problems, such as publish/subscribe,
 RPC-style request/reply, or service discovery. The API frees the
 programmer from worrying about details like connection management,
 retries, and other common considerations, so that they can focus on
 the application instead of the plumbing.
 .
 This package contains the shared library.

Package: libnng-dev
Section: libdevel
Architecture: any
Depends: libnng1 (= ${binary:Version}), ${misc:Depends}, libmbedtls-dev
Multi-Arch: same
Description: Lightweight Messaging Library - development
 Lightweight, broker-less library, offering a simple API to solve
 common recurring messaging problems, such as publish/subscribe,
 RPC-style request/reply, or service discovery. The API frees the
 programmer from worrying about details like connection management,
 retries, and other common considerations, so that they can focus on
 the application instead of the plumbing.
 .
 This package contains the header files needed for developing programs
 using libwebsockets and a static library.

## nng 1.9.0

=== docs/man/CMakeLists.txt ===
#
# Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
# Copyright 2018 Capitar IT Group BV <info@capitar.com>
# Copyright 2019 Devolutions <info@devolutions.net>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.

# We default to off here.
option(NNG_ENABLE_DOC "Enable building documentation." OFF)

if (NNG_ENABLE_DOC)
    find_program(ASCIIDOCTOR asciidoctor)
    if (NOT ASCIIDOCTOR)
        message(WARNING "Could not find asciidoctor: skipping docs")
        set(NNG_ENABLE_DOC OFF)
    else ()
        message(STATUS "Using asciidoctor at ${ASCIIDOCTOR}")
    endif ()
endif ()

if (NNG_ENABLE_DOC)
    set(NNG_DOCDIR ${CMAKE_CURRENT_SOURCE_DIR})

    set(NNG_A2M ${ASCIIDOCTOR} -b manpage -amanmanual='NNG Reference Manual')
    set(NNG_A2H ${ASCIIDOCTOR} -a nofooter -atoc=left -aicons=font -d manpage -b html5)

    macro(nng_man NAME SECT)

        add_custom_command(
                OUTPUT ${NAME}.${SECT}
                COMMAND ${NNG_A2M} -o ${NAME}.${SECT} ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
                MAIN_DEPENDENCY ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
        )

        add_custom_command(
                OUTPUT ${NAME}.${SECT}.html
                COMMAND ${NNG_A2H} -o ${NAME}.${SECT}.html ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
                MAIN_DEPENDENCY ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
        )

        set(NNG_MANS ${NNG_MANS} ${NAME}.${SECT})
        set(NNG_HTMLS ${NNG_HTMLS} ${NAME}.${SECT}.html)

        install(
                FILES ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.${SECT}.html
                DESTINATION ${CMAKE_INSTALL_DOCDIR}
        )
        install(
                FILES ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.${SECT}
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man${SECT}
        )

    endmacro(nng_man)

    set(NNG_MAN1
            nngcat
            )

    set(NNG_MAN3
            libnng
            nng_aio_abort
            nng_aio_alloc
            nng_aio_begin
            nng_aio_cancel
            nng_aio_count
            nng_aio_defer
            nng_aio_finish
            nng_aio_free
            nng_aio_get_input
            nng_aio_get_msg
            nng_aio_get_output
            nng_aio_result
            nng_aio_set_input
            nng_aio_set_iov
            nng_aio_set_msg
            nng_aio_set_output
            nng_aio_set_timeout
            nng_aio_stop
            nng_aio_wait
            nng_alloc
            nng_bus_open
            nng_close
            nng_ctx_close
            nng_ctx_get
            nng_ctx_getopt
            nng_ctx_id
            nng_ctx_open
            nng_ctx_recv
            nng_ctx_send
            nng_ctx_set
            nng_ctx_setopt
            nng_device
            nng_dial
            nng_dialer_close
            nng_dialer_create
            nng_dialer_get
            nng_dialer_getopt
            nng_dialer_id
            nng_dialer_set
            nng_dialer_setopt
            nng_dialer_start
            nng_free
            nng_getopt
            nng_inproc_register
            nng_ipc_register
            nng_listen
            nng_listener_close
            nng_listener_create
            nng_listener_get
            nng_listener_getopt
            nng_listener_id
            nng_listener_set
            nng_listener_setopt
            nng_listener_start
            nng_log
            nng_log_get_level
            nng_log_set_facility
            nng_log_set_level
            nng_log_set_logger
            nng_msg_alloc
            nng_msg_append
            nng_msg_body
            nng_msg_chop
            nng_msg_clear
            nng_msg_dup
            nng_msg_free
            nng_msg_get_pipe
            nng_msg_header
            nng_msg_header_append
            nng_msg_header_chop
            nng_msg_header_clear
            nng_msg_header_insert
            nng_msg_header_len
            nng_msg_header_trim
            nng_msg_insert
            nng_msg_len
            nng_msg_realloc
            nng_msg_set_pipe
            nng_msg_trim
            nng_pair_open
            nng_pipe_close
            nng_pipe_dialer
            nng_pipe_get
            nng_pipe_getopt
            nng_pipe_id
            nng_pipe_listener
            nng_pipe_notify
            nng_pipe_socket
            nng_pub_open
            nng_pull_open
            nng_push_open
            nng_recv
            nng_recv_aio
            nng_recvmsg
            nng_rep_open
            nng_req_open
            nng_respondent_open
            nng_send
            nng_send_aio
            nng_sendmsg
            nng_setopt
            nng_sleep_aio
            nng_socket_id
            nng_socket_get
            nng_socket_set
            nng_stats_free
            nng_stats_get
            nng_stat_bool
            nng_stat_child
            nng_stat_desc
            nng_stat_find
            nng_stat_find_dialer
            nng_stat_find_listener
            nng_stat_find_socket
            nng_stat_name
            nng_stat_next
            nng_stat_string
            nng_stat_timestamp
            nng_stat_type
            nng_stat_unit
            nng_stat_value
            nng_str_sockaddr
            nng_strdup
            nng_strerror
            nng_strfree
            nng_sub_open
            nng_surveyor_open
            nng_tcp_register
            nng_tls_register
            nng_url_clone
            nng_url_free
            nng_url_parse
            nng_version
            nng_ws_register
            nng_wss_register
            nng_zt_register
            )

    set(NNG_MAN3COMPAT
            nn_allocmsg
            nn_bind
            nn_close
            nn_cmsg
            nn_connect
            nn_device
            nn_errno
            nn_freemsg
            nn_get_statistic
            nn_getsockopt
            nn_poll
            nn_reallocmsg
            nn_recv
            nn_recvmsg
            nn_send
            nn_sendmsg
            nn_setsockopt
            nn_shutdown
            nn_socket
            nn_strerror
            nn_term
            nng_compat
            )

    set(NNG_MAN3HTTP
            nng_http_client_alloc
            nng_http_client_connect
            nng_http_client_free
            nng_http_client_get_tls
            nng_http_client_set_tls
            nng_http_client_transact
            nng_http_conn_close
            nng_http_conn_read
            nng_http_conn_read_all
            nng_http_conn_read_req
            nng_http_conn_read_res
            nng_http_conn_transact
            nng_http_conn_write
            nng_http_conn_write_all
            nng_http_conn_write_req
            nng_http_conn_write_res
            nng_http_handler_alloc
            nng_http_handler_free
            nng_http_handler_get_data
            nng_http_handler_set_data
            nng_http_handler_set_host
            nng_http_handler_set_method
            nng_http_handler_set_tree
            nng_http_hijack
            nng_http_req_add_header
            nng_http_req_alloc
            nng_http_req_copy_data
            nng_http_req_del_header
            nng_http_req_free
            nng_http_req_get_data
            nng_http_req_get_header
            nng_http_req_get_method
            nng_http_req_get_uri
            nng_http_req_get_version
            nng_http_req_reset
            nng_http_req_set_data
            nng_http_req_set_header
            nng_http_req_set_method
            nng_http_req_set_uri
            nng_http_req_set_version
            nng_http_res_add_header
            nng_http_res_alloc
            nng_http_res_alloc_error
            nng_http_res_copy_data
            nng_http_res_del_header
            nng_http_res_free
            nng_http_res_get_data
            nng_http_res_get_header
            nng_http_res_get_reason
            nng_http_res_get_status
            nng_http_res_get_version
            nng_http_res_reset
            nng_http_res_set_data
            nng_http_res_set_header
            nng_http_res_set_reason
            nng_http_res_set_status
            nng_http_res_set_version
            nng_http_server_add_handler
            nng_http_server_del_handler
            nng_http_server_get_addr
            nng_http_server_get_tls
            nng_http_server_hold
            nng_http_server_release
            nng_http_server_set_tls
            nng_http_server_start
            nng_http_server_stop
            )

    set(NNG_MAN3SUPP
            nng_clock
            nng_cv_alloc
            nng_cv_free
            nng_cv_until
            nng_cv_wait
            nng_cv_wake
            nng_cv_wake1
            nng_id_map
            nng_msleep
            nng_mtx_alloc
            nng_mtx_free
            nng_mtx_lock
            nng_mtx_unlock
            nng_opts_parse
            nng_random
            nng_socket_pair
            nng_thread_create
            nng_thread_destroy
            nng_thread_set_name
            )

    set(NNG_MAN3STR
            nng_stream_close
            nng_stream_free
            nng_stream_get
            nng_stream_recv
            nng_stream_send
            nng_stream_set
            nng_stream_dialer_alloc
            nng_stream_dialer_close
            nng_stream_dialer_dial
            nng_stream_dialer_free
            nng_stream_dialer_get
            nng_stream_dialer_set
            nng_stream_listener_accept
            nng_stream_listener_alloc
            nng_stream_listener_close
            nng_stream_listener_free
            nng_stream_listener_get
            nng_stream_listener_listen
            nng_stream_listener_set
            )

    set(NNG_MAN3TLS
            nng_tls_config_alloc
            nng_tls_config_auth_mode
            nng_tls_config_ca_chain
            nng_tls_config_ca_file
            nng_tls_config_cert_key_file
            nng_tls_config_free
            nng_tls_config_hold
            nng_tls_config_own_cert
            nng_tls_config_psk
            nng_tls_config_server_name
            nng_tls_engine_description
            nng_tls_engine_fips_mode
            nng_tls_engine_name
            )

    set(NNG_MAN5
            nng_aio
            nng_ctx
            nng_dialer
            nng_duration
            nng_iov
            nng_listener
            nng_msg
            nng_options
            nng_pipe
            nng_sockaddr
            nng_sockaddr_abstract
            nng_sockaddr_in
            nng_sockaddr_in6
            nng_sockaddr_inproc
            nng_sockaddr_ipc
            nng_sockaddr_zt
            nng_socket
            nng_stat
            nng_url

            nng_stream
            nng_stream_dialer
            nng_stream_listener

            nng_tcp_options
            nng_ipc_options
            nng_tls_config
            nng_tls_engine
            nng_tls_options
            )

    set(NNG_MAN7
            nng
            nng_bus
            nng_inproc
            nng_ipc
            nng_pair
            nng_pub
            nng_pull
            nng_push
            nng_rep
            nng_req
            nng_respondent
            nng_socket
            nng_sub
            nng_surveyor
            nng_tcp
            nng_tls
            nng_ws
            nng_zerotier
            )

    foreach (F ${NNG_MAN1})
        nng_man(${F} 1)
    endforeach ()

    foreach (F ${NNG_MAN3})
        nng_man(${F} 3)
    endforeach ()

    foreach (F ${NNG_MAN3COMPAT})
        nng_man(${F} 3compat)
    endforeach ()

    foreach (F ${NNG_MAN3HTTP})
        nng_man(${F} 3http)
    endforeach ()

    foreach (F ${NNG_MAN3STR})
        nng_man(${F} 3str)
    endforeach ()

    foreach (F ${NNG_MAN3SUPP})
        nng_man(${F} 3supp)
    endforeach ()

    foreach (F ${NNG_MAN3TLS})

=== src/supplemental/tls/wolfssl/CMakeLists.txt ===
#
# Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#
include(FindThreads)

if (NNG_TLS_ENGINE STREQUAL "wolf")
    message(NOTICE "
        ************************************************************
        Linking against WolfSSL may change license terms.
        Consult a lawyer and the license files for details.
        ************************************************************")
    nng_sources(wolfssl.c)

    # If wolfSSL was added by a consuming project, then we should use that
    # instance of it, instead of configuring our own.
    if (TARGET wolfssl)
        nng_link_libraries(wolfssl)
    else()
        # We want to prefer config mode over our local find package.
        if (NOT (DEFINED CMAKE_FIND_PACKAGE_PREFER_CONFIG))
            set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)
            find_package(wolfSSL REQUIRED)
            unset(CMAKE_FIND_PACKAGE_PREFER_CONFIG)
        else()
            find_package(wolfSSL REQUIRED)
        endif()
        nng_link_libraries_public(wolfssl::wolfssl)
    endif()

    check_library_exists(wolfssl::wolfssl wolfSSL_CTX_LoadCRLBuffer "" NNG_WOLFSSL_HAVE_CRL)
    check_library_exists(wolfssl::wolfssl wolfSSL_get_verify_result "" NNG_WOLFSSL_HAVE_VERIFY)
    check_library_exists(wolfssl::wolfssl wolfSSL_CTX_set_default_passwd_cb "" NNG_WOLFSSL_HAVE_PASSWORD)
    check_library_exists(wolfssl::wolfssl wolfSSL_get_peer_certificate "" NNG_WOLFSSL_HAVE_PEER_CERT)
    check_library_exists(wolfssl::wolfssl wolfSSL_CTX_SetTmpDH "" NNG_WOLFSSL_HAVE_DH)
    check_library_exists(wolfssl::wolfssl wolfSSL_CTX_set_psk_client_callback "" NNG_WOLFSSL_HAVE_PSK)

    if (NNG_WOLFSSL_HAVE_DH)
        nng_defines(NNG_WOLFSSL_HAVE_DH)
    else ()
        message(STATUS "wolfSSL configured without DH support.")
    endif ()

    if (NNG_WOLFSSL_HAVE_CRL)
        nng_defines(NNG_WOLFSSL_HAVE_CRL)
    else ()
        message(STATUS "wolfSSL configured without CRL support.")
    endif ()

    if (NNG_WOLFSSL_HAVE_PASSWORD)
        nng_defines(NNG_WOLFSSL_HAVE_PASSWORD)
    else ()
        message(STATUS "wolfSSL configured without password support.")
    endif ()

    if (NNG_WOLFSSL_HAVE_PEER_CERT)
        nng_defines(NNG_WOLFSSL_HAVE_PEER_CERT)
    else ()
        message(STATUS "wolfSSL configured without peer cert chain support.")
    endif ()

    if (NNG_WOLFSSL_HAVE_PSK)
        nng_defines(NNG_SUPP_TLS_PSK)
    else ()
        message(STATUS "wolfSSL configured without pre-shared key (PSK) support.")
    endif()

    nng_defines(NNG_TLS_ENGINE_INIT=nng_tls_engine_init_wolf)
    nng_defines(NNG_TLS_ENGINE_FINI=nng_tls_engine_fini_wolf)
    nng_defines(NNG_SUPP_TLS)
    nng_defines(NNG_TLS_ENGINE_WOLFSSL)
endif ()

=== debian/changelog ===
nng (1.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Disable TLS tests not working on buildds.
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 11 Oct 2024 19:46:00 +0200

nng (1.8.0-1) experimental; urgency=medium

  * New upstream release.
  * Ship documentation in a separate package.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 31 May 2024 17:14:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: devel
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 13), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf, libmbedtls-dev
+Build-Depends: debhelper-compat (= 13), dh-python, cmake, asciidoctor,
+ python3, protobuf-compiler, python3-protobuf, libmbedtls-dev
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://nng.nanomsg.org/
 
 Package: nng-utils
@@ -39,6 +40,7 @@
 Section: libdevel
 Architecture: any
 Depends: libnng1 (= ${binary:Version}), ${misc:Depends}, libmbedtls-dev
+Suggests: libnng-doc
 Multi-Arch: same
 Description: Lightweight Messaging Library - development
  Lightweight, broker-less library, offering a simple API to solve
@@ -50,3 +52,20 @@
  .
  This package contains the header files needed for developing programs
  using libwebsockets and a static library.
+
+Package: libnng-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends:
+ ${misc:Depends}
+Description: Lightweight Messaging Library - HTML documentation
+ Lightweight, broker-less library, offering a simple API to solve
+ common recurring messaging problems, such as publish/subscribe,
+ RPC-style request/reply, or service discovery. The API frees the
+ programmer from worrying about details like connection management,
+ retries, and other common considerations, so that they can focus on
+ the application instead of the plumbing.
+ .
+ This package installs HTML documentation for developing programs using
+ libwebsockets.

## nng 1.10.0

=== debian/changelog ===
nng (1.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 05 Jan 2025 21:12:14 +0100

nng (1.9.0-2) unstable; urgency=medium

  * Disable flaky self-tests (closes: #1088010).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 27 Dec 2024 10:40:47 +0100
